#include <SoftwareSerial.h>
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif
#define LED_PIN     6
#define LED_COUNT  257
#define RBIGHTNESS 30

//SoftwareSerial BT(1, 0);  // TX, RX of the Bluetooth Module

Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRBW + NEO_KHZ800);


int btn1 = A0;         // the number of the input pin
int btn2 = A1;
int p1 = A2;
int p2 = A3;
int p3 = A4;
int p4 = A5;
//int ledStrip = 6;      // the number of the output pin1
int led1 = 4;
int led2 = 5;
int var = 0;          // variable for the switch
int r, g, b, w;
int state2 = LOW;      // the current state of the output pin2
int state = HIGH;      // the current state of the output pin1
int reading;
int reading1;
int stat = LOW;// the current reading from the input pin
int previous = LOW;    // the previous reading from the input pin
int bright = 0;
int state3 = LOW;

// the follow variables are long's because the time, measured in miliseconds,
// will quickly become a bigger number than can be stored in an int.
long time = 0;         // the last time the output pin was toggled
long debounce = 200;   // the debounce time, increase if the output flickers

void setup()
{
  //BT.begin(9600);
  Serial.begin (9600);
  Serial.println("LED ring connected");
  pinMode(btn1, INPUT);
  pinMode(btn2, INPUT);
  pinMode(p1, INPUT);
  pinMode(p2, INPUT);
  pinMode(p3, INPUT);
  pinMode(p4, INPUT);

  //pinMode(ledStrip, OUTPUT);
  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  strip.begin();           // INITIALIZE NeoPixel strip object (REQUIRED)
  strip.show();            // Turn OFF all pixels ASAP
  strip.setBrightness(RBIGHTNESS); // Set BRIGHTNESS to about 1/5 (max = 255)
}

void loop() {
  digitalWrite(led1, HIGH);
  digitalWrite(led2, HIGH);
  if (Serial.available()) {
    while (Serial.available()) {
      state3 = LOW;
      digitalWrite(led1, LOW);
      delay(500);
      digitalWrite(led1, HIGH);
      delay(500);
      digitalWrite(led1, LOW);
      delay(500);
      digitalWrite(led1, HIGH);
      char a;
      char b;
      a = (char)Serial.read();
      if (a == 'o') {
        colorWipe(strip.Color(0, 0, 0, 255), 5);
        Serial.println("LED ring is on. Color: white");
      }
      if (a == 'w') {
        Serial.println("White");
        colorWipe(strip.Color(0, 0, 0, 255), 5);
      }
      if (a == 'r') {
        Serial.println("Red");
        colorWipe(strip.Color(255, 0, 0, 0), 5);
      }
      if (a == 'g') {
        Serial.println("Green");
        colorWipe(strip.Color(0, 255, 0, 0) , 50); // Green
      }
      if (a == 'b') {
        Serial.println("Blue");
        colorWipe(strip.Color(0, 0, 255, 0) , 50); // Green
      }
      if (a == 'f') {
        Serial.println("LED ring is off");
        colorWipe(strip.Color(0, 0, 0, 0), 5);
      }
      if (a == 'd') {
        Serial.println("Demo mode ON");
        whiteOverRainbow(75, 5);
      }
      if (a == 'y') {
        Serial.println("Yellow");
        for (int i = 0; i < strip.numPixels(); i++) {
          strip.setPixelColor(i, 255, 255, 0, 0);
        }
        strip.show();
      }
      if (a == 'p') {
        Serial.println("Read potentiomere mode ON");
        while (state3 == LOW) {
          r = analogRead(p1);
          g = analogRead(p2);
          b = analogRead(p3);
          w = analogRead(p4);
          map (r, 0, 1023, 0, 255);
          map (g, 0, 1023, 0, 255);
          map (b, 0, 1023, 0, 255);
          map (w, 0, 1023, 0, 255);
          for (int i = 0; i < strip.numPixels(); i++) {
            strip.setPixelColor(i, r, g, b, w);
          }
          strip.show();
          state3 = digitalRead(btn1);
          delay(500);
        }
      }
    }
  }

  reading = digitalRead(btn1);
  reading1 = digitalRead(btn2);
  digitalWrite (led1, HIGH);
  digitalWrite (led2, HIGH);
  //  if the input just went from LOW and HIGH and we've waited long enough
  //   to ignore any noise on the circuit, toggle the output pin and remember
  //   the time
  if (reading == HIGH && previous == LOW && millis() - time > debounce) {
    var = var + 1;
    if (var > 9) {
      var = 0; //zero var
    }
    switch (var) {
      case 1:
        for (int i = 0; i < strip.numPixels(); i++) {
          strip.setPixelColor(i, 0, 0, 0, 255);
        }
        strip.show();
        delay(1000);
        break;
        break;
      case 2:
        for (int i = 0; i < strip.numPixels(); i++) {
          strip.setPixelColor(i, 255, 0, 0, 0);
        }
        strip.show();
        delay(1000);
        break;
      case 3:
        for (int i = 0; i < strip.numPixels(); i++) {
          strip.setPixelColor(i, 0, 255, 0, 0);
        }
        strip.show();
        delay(1000);
        break;
      case 4:
        for (int i = 0; i < strip.numPixels(); i++) {
          strip.setPixelColor(i, 0, 0, 255, 0);
        }
        strip.show();
        delay(1000);
        break;
      case 5:
          delay (500);
          while (state3 == LOW) {
          r = analogRead(p1);
          g = analogRead(p2);
          b = analogRead(p3);
          w = analogRead(p4);
          map (r, 0, 1023, 0, 255);
          map (g, 0, 1023, 0, 255);
          map (b, 0, 1023, 0, 255);
          map (w, 0, 1023, 0, 255);
          for (int i = 0; i < strip.numPixels(); i++) {
            strip.setPixelColor(i, r, g, b, w);
          }
          strip.show();
          state3 = digitalRead(btn1);
          delay(500);
        }
        state3 = LOW;
        break;
      case 6:
        colorWipe(strip.Color(0, 0, 0, 255) , 50); // True white (not RGB white)
        break;
      case 7:
        colorWipe(strip.Color(255, 0, 0, 0) , 50); // Red
        break;
      case 8:
        colorWipe(strip.Color(0, 255, 0, 0) , 50); // Green
        break;
      case 9:
        colorWipe(strip.Color(0, 0, 255, 0), 50); // Blue
        break;
      default:
        colorWipe(strip.Color(0, 0, 0,  0)     , 50);
        break;

        time = millis();
        //  previous = reading;
    }

  }
  if (reading1 == HIGH && previous == LOW && millis() - time > debounce) {
    var = var - 1;
    if (var < 0) {
      var = 8; //zero var
    }

    switch (var) {
      case 1:
        for (int i = 0; i < strip.numPixels(); i++) {
          strip.setPixelColor(i, 0, 0, 0, 255);
        }
        strip.show();
        delay(1000);
        break;
      case 2:
        for (int i = 0; i < strip.numPixels(); i++) {
          strip.setPixelColor(i, 255, 0, 0, 0);
        }
        strip.show();
        delay(1000);
        break;
      case 3:
        for (int i = 0; i < strip.numPixels(); i++) {
          strip.setPixelColor(i, 0, 255, 0, 0);
        }
        strip.show();
        delay(1000);
        break;
      case 4:
        for (int i = 0; i < strip.numPixels(); i++) {
          strip.setPixelColor(i, 0, 0, 255, 0);
        }
        strip.show();
        delay(1000);
        break;
      case 5:
          delay (500);
          while (state3 == LOW) {
          r = analogRead(p1);
          g = analogRead(p2);
          b = analogRead(p3);
          w = analogRead(p4);
          map (r, 0, 1023, 0, 255);
          map (g, 0, 1023, 0, 255);
          map (b, 0, 1023, 0, 255);
          map (w, 0, 1023, 0, 255);
          for (int i = 0; i < strip.numPixels(); i++) {
            strip.setPixelColor(i, r, g, b, w);
          }
          strip.show();
          state3 = digitalRead(btn2);
          delay(500);
        }
        state3 = LOW;
        break;
      case 6:
        colorWipe(strip.Color(0, 0, 0, 255) , 50); // True white (not RGB white)
        break;
      case 7:
        colorWipe(strip.Color(255, 0, 0, 0) , 50); // Red
        break;
      case 8:
        colorWipe(strip.Color(0, 255, 0, 0) , 50); // Green
        break;
      case 9:
        colorWipe(strip.Color(0, 0, 255, 0), 50); // Blue
        break;
      default:
        colorWipe(strip.Color(0, 0, 0,  0)     , 50);
        break;

        time = millis();
        //  previous = reading;
    }

  }

}



// Fill strip pixels one after another with a color. Strip is NOT cleared
// first; anything there will be covered pixel by pixel. Pass in color
// (as a single 'packed' 32-bit value, which you can get by calling
// strip.Color(red, green, blue) as shown in the loop() function above),
// and a delay time (in milliseconds) between pixels.


void colorWipe(uint32_t color, int wait) {
  for (int i = 0; i < strip.numPixels(); i++) { // For each pixel in strip...
    strip.setPixelColor(i, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    //delay(wait);                           //  Pause for a moment
  }
}

void whiteOverRainbow(int whiteSpeed, int whiteLength) {

  if (whiteLength >= strip.numPixels()) whiteLength = strip.numPixels() - 1;

  int      head          = whiteLength - 1;
  int      tail          = 0;
  int      loops         = 3;
  int      loopNum       = 0;
  uint32_t lastTime      = millis();
  uint32_t firstPixelHue = 0;

  for (;;) { // Repeat forever (or until a 'break' or 'return')
    for (int i = 0; i < strip.numPixels(); i++) { // For each pixel in strip...
      if (((i >= tail) && (i <= head)) ||     //  If between head & tail...
          ((tail > head) && ((i >= tail) || (i <= head)))) {
        strip.setPixelColor(i, strip.Color(0, 0, 0, 255)); // Set white
      } else {                                             // else set rainbow
        int pixelHue = firstPixelHue + (i * 65536L / strip.numPixels());
        strip.setPixelColor(i, strip.gamma32(strip.ColorHSV(pixelHue)));
      }
    }

    strip.show(); // Update strip with new contents
    // There's no delay here, it just runs full-tilt until the timer and
    // counter combination below runs out.

    firstPixelHue += 40; // Advance just a little along the color wheel

    if ((millis() - lastTime) > whiteSpeed) { // Time to update head/tail?
      if (++head >= strip.numPixels()) {     // Advance head, wrap around
        head = 0;
        if (++loopNum >= loops) return;
      }
      if (++tail >= strip.numPixels()) {     // Advance tail, wrap around
        tail = 0;
      }
      lastTime = millis();                   // Save time of last movement
    }
  }
}

void pulseWhite(uint8_t wait) {
  for (int j = 0; j < 256; j++) { // Ramp up from 0 to 255
    // Fill entire strip with white at gamma-corrected brightness level 'j':
    strip.fill(strip.Color(0, 0, 0, strip.gamma8(j)));
    strip.show();
    delay(wait);
  }

  for (int j = 255; j >= 0; j--) { // Ramp down from 255 to 0
    strip.fill(strip.Color(0, 0, 0, strip.gamma8(j)));
    strip.show();
    delay(wait);
  }
}

void rainbowFade2White(int wait, int rainbowLoops, int whiteLoops) {
  int fadeVal = 0, fadeMax = 100;

  // Hue of first pixel runs 'rainbowLoops' complete loops through the color
  // wheel. Color wheel has a range of 65536 but it's OK if we roll over, so
  // just count from 0 to rainbowLoops*65536, using steps of 256 so we
  // advance around the wheel at a decent clip.
  for (uint32_t firstPixelHue = 0; firstPixelHue < rainbowLoops * 65536;
       firstPixelHue += 256) {

    for (int i = 0; i < strip.numPixels(); i++) { // For each pixel in strip...

      // Offset pixel hue by an amount to make one full revolution of the
      // color wheel (range of 65536) along the length of the strip
      // (strip.numPixels() steps):
      uint32_t pixelHue = firstPixelHue + (i * 65536L / strip.numPixels());

      // strip.ColorHSV() can take 1 or 3 arguments: a hue (0 to 65535) or
      // optionally add saturation and value (brightness) (each 0 to 255).
      // Here we're using just the three-argument variant, though the
      // second value (saturation) is a constant 255.
      strip.setPixelColor(i, strip.gamma32(strip.ColorHSV(pixelHue, 255,
                                           255 * fadeVal / fadeMax)));
    }

    strip.show();
    delay(wait);

    if (firstPixelHue < 65536) {                             // First loop,
      if (fadeVal < fadeMax) fadeVal++;                      // fade in
    } else if (firstPixelHue >= ((rainbowLoops - 1) * 65536)) { // Last loop,
      if (fadeVal > 0) fadeVal--;                            // fade out
    } else {
      fadeVal = fadeMax; // Interim loop, make sure fade is at max
    }
  }

  for (int k = 0; k < whiteLoops; k++) {
    for (int j = 0; j < 256; j++) { // Ramp up 0 to 255
      // Fill entire strip with white at gamma-corrected brightness level 'j':
      strip.fill(strip.Color(0, 0, 0, strip.gamma8(j)));
      strip.show();
    }
    delay(1000); // Pause 1 second
    for (int j = 255; j >= 0; j--) { // Ramp down 255 to 0
      strip.fill(strip.Color(0, 0, 0, strip.gamma8(j)));
      strip.show();
    }
  }

  delay(500); // Pause 1/2 second
}
